-- reporter: make sure the whole guild knows of your success and shame
-- Original idea by Harpo
-- modified heavily & redesigned by Estrian
-- v1.5a Fixed a bug reporting yourself as killer and uses proper /me tags
-- v1.6 Made plugin fully automatic with group toggles

declare('reporter', {})

reporter.toggle={}
reporter.Init={}
reporter.someDeath={}
reporter.GroupEvents={}
reporter.ArgToggle={}

reporter.pluginState = true

function reporter.ArgToggle()
	if reporter.pluginState == true then
		reporter.pluginState = false
		print('reporter toggled, OFF')
	else 
		reporter.pluginState = true
		print('reporter toggled, ON')
	end
end

function reporter.toggle(data,args)
	if not args then
		print('\127ffffffCommands are /reporter [toggle/on/off]\127o')
	elseif args[1]=='toggle' then
		reporter.ArgToggle()
	elseif args[1]=='on' then 
		reporter.pluginState = true
		print('reporter ON')
	elseif args[1]=='off' then 
		reporter.pluginState = false
		print('reporter OFF')
	else
	print('\127ffffffNot a valid argument\127o')
	end
end

function reporter.Init:OnEvent(event)
	reporter.pluginState = true
end

function reporter.GroupEvents:OnEvent(eventname, args)
	if eventname=='GROUP_CREATED' or eventname =='GROUP_SELF_JOINED' then
		reporter.pluginState = false
		print('\127ffffffreporter Autotoggled to OFF (group joined)\127o')
	elseif eventname=='GROUP_SELF_LEFT' then
		reporter.pluginState = true
		print('\127ffffffreporter Auto-toggled to ON (group left)\127o')
	end
end

function reporter.someDeath:OnEvent(event, deadguyID, killerID)
	if reporter.pluginState == true then
		if (not GetPlayerName(deadguyID):match("^%*")) then
			if (not GetPlayerName(killerID):match("^%*")) then
				local selfID = GetCharacterID()
				if (deadguyID == killerID) then
					SendChat("/me managed to suicide with style" , "GUILD")
				elseif (deadguyID == selfID) and (killerID ~= selfID) then
					local killer = GetPlayerName(killerID)
					SendChat("/me was destroyed by ".. killer, "GUILD")
				else
					local deadguy = GetPlayerName(deadguyID) or "none"
					local killer = GetPlayerName(killerID) or "none"
					SendChat("/me destroyed " .. deadguy, "GUILD")
				end
			end
		end
	end
end

RegisterEvent(reporter.someDeath, "PLAYER_DIED")
RegisterEvent(reporter.Init, "PLAYER_ENTERED_GAME")
RegisterEvent(reporter.GroupEvents, "GROUP_CREATED")
RegisterEvent(reporter.GroupEvents, "GROUP_SELF_LEFT")
RegisterEvent(reporter.GroupEvents, "GROUP_SELF_JOINED")

RegisterUserCommand('reporter', reporter.toggle)

-- for the anti-spam omit just store the messages in a table with table.insert(), then create a Timer() object and use :SetTimeout() to extract them.